package com.catarc.traceability.repository;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectKey;
import org.apache.ibatis.annotations.Update;
import org.springframework.stereotype.Repository;

import com.catarc.traceability.entity.Role;
import com.catarc.traceability.entity.UserRole;
import com.catarc.traceability.repository.base.BaseRepository;
import com.isoft91.web.base.repository.DynamicQueryRepository;


@Repository
public interface UserRoleRepository extends BaseRepository<Role>,DynamicQueryRepository{
	
	@SelectKey(statement="select sys_guid() from dual", before = true, keyProperty = "pkTRoleId", resultType = String.class)
	@Insert("INSERT INTO T_ROLE(PK_T_ROLE_ID,NAME,REMARK,CREATE_TIME,DEL_FLAG ) VALUES(#{pkTRoleId},#{name},#{remark},#{createTime},#{delFlag})")
	int insertRole(Role role);
	
	@Update("UPDATE T_ROLE  SET DEL_FLAG ='1' WHERE  PK_T_Role_Id = #{pkTRoleId}")
	int updateDelete(Role role);
	
	@Select("select * from T_ROLE WHERE PK_T_Role_Id = #{pkTRoleId}")
	Role selectDetaiRole(Role role);
	
	@Update("UPDATE T_ROLE  SET \"NAME\" = #{name},\"REMARK\" = #{remark}, UPDATE_TIME=#{updateTime} WHERE  PK_T_Role_Id = #{pkTRoleId}")
	int updateRole(Role role);
	
	@SelectKey(statement="select sys_guid() from dual", before = true, keyProperty = "pkTUsrolrId", resultType = String.class)
	@Insert("INSERT INTO T_USER_ROLE(PK_T_USROLE_ID,ROLE_ID,CREATE_TIME,DEL_FLAG,USER_ID ) VALUES(#{pkTUsrolrId},#{roleId},#{createTime},#{delFlag},#{userId})")
	int  insertRoleToUser(UserRole userRole);
	/*********************************开始*********************************************/
	/**
	 * 获取角色Id
	 * @MethodName:getRoleId
	 * @author: wangyao
	 * @email: 842261834@qq.com 
	 * @date 2017年8月29日 下午9:01:10
	 * @version V1.0
	 * @param userId
	 * @return
	 */
	@Select("SELECT ROLE_ID FROM T_USER_ROLE WHERE USER_ID = #{userId}")
	String getRoleId(String userId);
	
	
	/*************************************结束*****************************************/
	@Delete("DELETE FROM T_USER_ROLE WHERE PK_T_USROLE_ID = #{pkTUsrolrId}")
	void deleteUserRole(UserRole userRole);
	
	@Select("SELECT ROLE_ID FROM T_USER_ROLE WHERE USER_ID =#{pkId}")
	String selectRoleByUserId(String pkId);
	
	@Update("UPDATE T_USER_ROLE SET ROLE_ID=#{roleId} WHERE USER_ID=#{userId}")
	int updateByUserAndRoleIdKeySelective(UserRole userRole);
	
	@Select("SELECT * FROM T_ROLE WHERE \"NAME\" = #{name} AND PK_T_ROLE_ID != #{pkTRoleId} AND DEL_FLAG = '0'")
	List<Map<String,Object>> judgeUpdateRoleName(Role role);
	
	@Select("SELECT * FROM T_ROLE WHERE \"NAME\" = #{name} AND DEL_FLAG = '0'")
	List<Map<String, Object>> dealCreateRoleName(Role role);
}
