package com.catarc.traceability.service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.stereotype.Service;

import com.catarc.traceability.datasource.DataSource;
import com.catarc.traceability.entity.Authority;
import com.catarc.traceability.entity.User;
import com.catarc.traceability.repository.AuthorityRepository;
import com.catarc.traceability.repository.UserRepository;
import com.catarc.traceability.repository.UserRoleRepository;
import com.catarc.traceability.service.base.BaseAbstractService;
import com.isoft91.web.base.pager.PaginationEntity;

/**
 * 登录service
 * @ProjectName:traceability
 * @ClassName:LoginService.java
 * @Description: 请务必自行补充代码核心描述
 * @Copyright: Copyright (c) 2017
 * @author: wangyao
 * @email: 842261834@qq.com 
 * @date 2017年8月28日 下午3:02:31
 * @version V1.0
 */
@Service
public class LoginService extends BaseAbstractService<User>{

	@Autowired
	private UserRepository userRepository;
	
	@Autowired
	private UserRoleRepository UserRoleRepository;
	
	@Autowired
	private AuthorityRepository authorityRepository;
	
	@Override
	public User insert(User var1) throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public User update(User var1) throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public User delete(User var1) throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * 登录
	 * @MethodName:getEntity
	 * @author: wangyao
	 * @email: 842261834@qq.com 
	 * @date 2017年8月29日 下午1:36:05
	 * @version V1.0
	 * @param var1
	 * @return
	 * @throws DataAccessException
	 */
	@Override
	public User getEntity(User var1) throws DataAccessException {
		User user = userRepository.login(var1);
		return user;
	}

	@Override
	public List<User> getEntitiesByPrimaryKeys(String var1)
			throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int deleteEntitiesByPrimaryKeys(String var1)
			throws DataAccessException {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public List<Map<String, Object>> queryDataNotPagination(Object... var1)
			throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<Map<String, Object>> queryDataWithGridUI_automatic(
			PaginationEntity var1, Object... var2) throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}
	
	/**
	 * 连续登录五次锁定
	 * @MethodName:updateLoginTimes
	 * @author: wangyao
	 * @email: 842261834@qq.com 
	 * @date 2017年8月29日 下午1:35:19
	 * @version V1.0
	 * @param user
	 * @return
	 */
	public int updateLoginTimes(User user){
		int times = userRepository.updateLoginTimes(user);
		return times;
	}
	
	/**
	 * 查询该用户名第几次登陆失败
	 * @MethodName:selectDelFlag
	 * @author: wangyao
	 * @email: 842261834@qq.com 
	 * @date 2017年8月29日 下午2:19:24
	 * @version V1.0
	 * @return
	 */
	  @DataSource("oracle")
	public User selectLoginTimes(String userName){
		User res = userRepository.selectLoginTimes(userName);
		return res;
	}
	 
	  /**
	   * 获取用户角色Id
	   * @MethodName:userRoleId
	   * @author: wangyao
	   * @email: 842261834@qq.com 
	   * @date 2017年8月29日 下午9:10:47
	   * @version V1.0
	   * @param userId
	   * @return
	   */
	 public String userRoleId(String userId){
		String roleId = UserRoleRepository.getRoleId(userId);
		return roleId;
	}
	 
	 /**
	  * 查询用户权限
	  * @MethodName:selectUserAuthority
	  * @author: wangyao
	  * @email: 842261834@qq.com 
	  * @date 2017年8月29日 下午9:28:06
	  * @version V1.0
	  * @param userId
	  * @return
	  */
	public Map selectUserAuthority(String roleId){
		List<Authority> list = authorityRepository.selectUserAuthority(roleId);
		List<Authority> listAuthBase = new ArrayList<Authority>();
		List<Authority> listAuthOrige = new ArrayList<Authority>();
		List<Authority> listAuthDetail = new ArrayList<Authority>();
		List<Authority> listAuthSys = new ArrayList<Authority>();
		Map map=new HashMap<Object,Object>();
		for (int i = 0; i < list.size(); i++) {
			if(list.get(i).getTrAnName().equals("基础信息管理")){
				listAuthBase.add(list.get(i));
			}else if(list.get(i).getTrAnName().equals("溯源信息管理")){
				listAuthOrige.add(list.get(i));
			}else if(list.get(i).getTrAnName().equals("溯源信息查询")){
				listAuthDetail.add(list.get(i));
			}else if(list.get(i).getTrAnName().equals("系统管理")){
				listAuthSys.add(list.get(i));
			}
		}
		map.put("基础信息管理", listAuthBase);
		map.put("溯源信息管理", listAuthOrige);
		map.put("溯源信息查询", listAuthDetail);
		map.put("系统管理", listAuthSys);
		return map;
	} 
	
	/**
	 * 登陆成功后更改信息
	 * @MethodName:updateLoginInfo
	 * @author: wangyao
	 * @email: 842261834@qq.com 
	 * @date 2017年8月30日 下午5:15:22
	 * @version V1.0
	 * @param user
	 * @return
	 */
	public int updateLoginInfo(User user){
		int flag = userRepository.updateLoginInfo(user);
		return flag;
	}
	
	/**
	 * 用户修改密码
	 * @MethodName:updatePwd
	 * @author: wangyao
	 * @email: 842261834@qq.com 
	 * @date 2017年8月31日 上午11:12:14
	 * @version V1.0
	 * @param user
	 * @return
	 */
	public int updatePwd(User user){
		int flag = userRepository.UpdatePwd(user);
		return flag;
	}
	
	/**
	 * 如果用户被锁用户登录次数清零，用户状态改为停用
	 * @MethodName:updateUserStateWhileLock
	 * @author: wangyao
	 * @email: 842261834@qq.com 
	 * @date 2017年9月8日 下午3:23:05
	 * @version V1.0
	 * @param user
	 * @return
	 */
	public int updateUserStateWhileLock(String userName){
		User user = new User();
		user.setUserName(userName);
		int flag = userRepository.updateUserStateWhileLockRU(user);
		return flag;
	}

	public int originPwd(User user) {
		// TODO Auto-generated method stub
		User run =userRepository.originPwd(user);
		if(run!=null){
			if(user.getFirstpwd().equals(run.getUserPwd())){
				return 2;
			}else{
				
				return 1;
			}
		}else{
			return 0;
		}
	}

	public String selectRoleId(String id) {
		// TODO Auto-generated method stub
		return userRepository.selectRoleId(id);
	}

	public int updateUserStateWhileLockTo(String decodeUserName) {
		// TODO Auto-generated method stub
		User user = new User();
		user.setUserName(decodeUserName);
		int flag = userRepository.updateUserStateWhileLockRUTo(user);
		return flag;
	}
	
}
