package com.catarc.traceability.service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.catarc.traceability.datasource.DataSource;
import com.catarc.traceability.entity.Order;
import com.catarc.traceability.repository.OrderRepository;
import com.catarc.traceability.service.base.BaseAbstractService;
import com.isoft91.web.base.pager.PaginationEntity;

/**
 * 
 * 订单管理service
 * @ProjectName:traceability
 * @ClassName:OrderService.java
 * @Description: 请务必自行补充代码核心描述
 * @Copyright: Copyright (c) 2017
 * @author: wangyao
 * @email: 842261834@qq.com 
 * @date 2017年1月14日 下午2:09:39
 * @version V1.0
 */
@Service
public class OrderService  extends BaseAbstractService<Order> {

	@Autowired
	private OrderRepository orderRepository;
	
	@Override
	public Order insert(Order var1) throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Order update(Order var1) throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Order delete(Order var1) throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Order getEntity(Order var1) throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<Order> getEntitiesByPrimaryKeys(String var1)
			throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int deleteEntitiesByPrimaryKeys(String var1)
			throws DataAccessException {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public List<Map<String, Object>> queryDataNotPagination(Object... var1)
			throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public List<Map<String, Object>> queryDataWithGridUI_automatic(PaginationEntity var1, Object... var2)
			throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	

	/**
	 * 分页查询全部订单
	 * @MethodName:queryAllOrder
	 * @author: yangxuenan
	 * @email: 958380650@qq.com
	 * @date 2017年9月26日 上午11:18:16
	 * @version V1.0
	 * @param order
	 * @return
	 */
	@DataSource("oracle")
    @Transactional(readOnly = true, propagation = Propagation.REQUIRED, rollbackFor = Exception.class)
    public List<Map<String, Object>> queryAllOrder(Order order){
        StringBuffer sbuffer = new StringBuffer();
        StringBuffer pagebuffer = new StringBuffer();
        sbuffer.append(" where DEL_FLAG=0 ");
        int pages = order.getPage()*order.getLimit()+1;
        int limits = (order.getPage()-1)*order.getLimit();
        String where = " rn < " +pages+ " AND rn>"+limits+" ";
        pagebuffer.append(where);
        String vin=order.getOrder_name();
        String agent=order.getAgent();
        String start=order.getStartTime();
        String end=order.getEndTime();
        String startTime = null;
        String endTime = "";
        if(!StringUtils.isEmpty(start)){
             startTime = start+" 00:00:00";
        }
        if(!StringUtils.isEmpty(end)){
             endTime = end + " 23:59:59";
        }
        if(!StringUtils.isEmpty(vin)){
            sbuffer.append( " AND PK_T_ORDER_ONAME LIKE " + "'%"+vin+"%'");
        }
        if(!StringUtils.isEmpty(agent)){
            sbuffer.append( " AND AGENT LIKE " + "'%"+agent+"%'");
        }
        if(!StringUtils.isEmpty(startTime) && !StringUtils.isEmpty(endTime)){
            sbuffer.append(" AND O_CRT_TIME >= \"TO_DATE\"('" + startTime + "', 'YYYY-MM-DD HH24:MI:SS') "
                    + "AND O_CRT_TIME <= \"TO_DATE\"('" + endTime+"', 'YYYY-MM-DD HH24:MI:SS') ");
        }else if( !StringUtils.isEmpty(startTime)){
            sbuffer.append(" AND O_CRT_TIME >= \"TO_DATE\"('" + startTime + "', 'YYYY-MM-DD HH24:MI:SS') ");
        }else if( !StringUtils.isEmpty(endTime) ){
            sbuffer.append(" AND O_CRT_TIME <= \"TO_DATE\"('" + endTime + "', 'YYYY-MM-DD HH24:MI:SS') ");
        }
        
        pagebuffer.append(" ORDER BY O_CRT_TIME DESC ");
        List<Map<String, Object>> OrderList = orderRepository.dynamicQuery("select * from(select a.*,rownum rn from (select * from T_ORDER)a " + sbuffer.toString() + ")", null, pagebuffer.toString());
        return OrderList;
    }
    /**
     * 获取数据总数(layui)
     * @MethodName:queryAllLibrary
     * @author: wenxin
     * @email: 1329488952@qq.com
     * @date 2017年9月20日 下午2:24:00
     * @version V1.0
     * @return
     */
    
    @DataSource("oracle")
    @Transactional(readOnly = true, propagation = Propagation.REQUIRED, rollbackFor = Exception.class)
    public List<Map<String, Object>> countOrder(Order order){
        StringBuffer sbuffer = new StringBuffer();
        String searchWhere = " DEL_FLAG=0";
        sbuffer.append(searchWhere);
        String vin=order.getOrder_name();
        String agent=order.getAgent();
        String start=order.getStartTime();
        String end=order.getEndTime();
        String startTime = null;
        String endTime = "";
        if(!StringUtils.isEmpty(start)){
             startTime = start+" 00:00:00";
        }
        if(!StringUtils.isEmpty(end)){
             endTime = end + " 23:59:59";
        }
        if(!StringUtils.isEmpty(vin)){
            sbuffer.append( " AND PK_T_ORDER_ONAME LIKE " + "'%"+vin+"%'");
        }
        if(!StringUtils.isEmpty(agent)){
            sbuffer.append( " AND AGENT LIKE " + "'%"+agent+"%'");
        }
        if(!StringUtils.isEmpty(startTime) && !StringUtils.isEmpty(endTime)){
            sbuffer.append(" AND O_CRT_TIME >= \"TO_DATE\"('" + startTime + "', 'YYYY-MM-DD HH24:MI:SS') "
                    + "AND O_CRT_TIME <= \"TO_DATE\"('" + endTime+"', 'YYYY-MM-DD HH24:MI:SS') ");
        }else if( !StringUtils.isEmpty(startTime)){
            sbuffer.append(" AND O_CRT_TIME >= \"TO_DATE\"('" + startTime + "', 'YYYY-MM-DD HH24:MI:SS') ");
        }else if( !StringUtils.isEmpty(endTime) ){
            sbuffer.append(" AND O_CRT_TIME <= \"TO_DATE\"('" + endTime + "', 'YYYY-MM-DD HH24:MI:SS') ");
        }
        sbuffer.append(" ORDER BY O_CRT_TIME DESC ");
        
        List<Map<String, Object>> list = new ArrayList<>();
        list = orderRepository.dynamicQuery("select count(*) AS totals from \"T_ORDER\"" ,null, sbuffer.toString());
        return list;
    }


}
